


; Program to count ions that hit this array
;
; Appelhans  June 2002


; definition of user adjustable variables  -----------------------

			 ; ion flight control parameters

defa _rerun 					1		; to turn rerun on (1) or off (0)

  ; ---------- adjustable at beginning of flight -----------------

			 ; charge recording variables

defa hit_faraday_cup			0		  ; ions hitting faraday cup
defa _start_output_at_ion_number  1000	  ; to start output of data
defa _reset_ion_counter_at		  1000	  ; to start counter again
defa _kill_time 				   50	  ; protect against ion trapped in source
defa _x_stop					   80	  ; point where ion is counted (mm)



; program segments below --------------------------------------------


seg Other_Actions

;  ________ used to record trajectories only during a set period _____________


	rcl _reset_ion_counter_at
	rcl ion_number
	x>=y goto reset

	rcl _kill_time						 ; check for stalled ion
	rcl Ion_Time_of_Flight				 ; get ion's time of flight
	x>y goto kill						 ; if stalled, kill it
										 ; else
	rcl ion_px_mm rcl _x_stop x<y goto cnt1 	 ; test for ion hitting FC
	goto skipk							 ; else, keep going

lbl cnt1								 ; count ions hitting  FC
	rcl ion_px_mm
	message ; #
	-4 sto ion_splat					 ; kill ion
	rcl hit_faraday_cup 1 + 			 ; increment count of ions hitting FC
	sto hit_faraday_cup
	rcl _start_output_at_ion_number 	 ; check to see if time to output
	rcl Ion_number
	x<y goto skipk
	rcl hit_faraday_cup
	rcl Ion_number
	message ; #  #
	rcl _reset_ion_counter_at			 ; check to see if time to reset counters
	rcl ion_number
	x>=y goto reset
	goto skipk


lbl skipk								 ; test for update of ion counters
	rcl _reset_ion_counter_at
	rcl ion_number
	x>=y goto reset

	exit

lbl reset								   ; reset counters
	rcl hit_faraday_cup
	rcl Ion_number
	message ; reset  # #

	0 sto hit_faraday_cup
	-4 sto ion_splat
	exit

lbl kill								   ; kills ion
	-4 sto ion_splat
;	 rcl ion_time_of_flight
;	 message ; ion killed  #

;------------------------------------------------------------------------
seg Terminate
;			 rcl _rerun
;			 sto rerun_flym 			   ; reset rerun mode
